import RegFile::*;
import RWire::*;
import ProcTypes::*;

//-----------------------------------------------------------
// Register file module
//-----------------------------------------------------------

interface BRegFile #(type index_t, type data_t);
   method Action upd(index_t addr, data_t data);
   method data_t sub(index_t addr);
endinterface

module mkBRegFile(RegFile#(index_t, data_t)) 
   provisos (Bits#(index_t, size_index),
	     Bits#(data_t, size_data),
	     Eq#(index_t),
	     Bounded#(index_t) );

   RegFile#(index_t, data_t) rf <- mkRegFileWCF(minBound, maxBound);
   RWire#(Tuple2#(index_t, data_t)) rw <-mkRWire();

   method Action upd (index_t r, data_t d);
      rf.upd(r,d);
      rw.wset(tuple2(r,d));
   endmethod

   method data_t sub (index_t r);
      case (rw.wget()) matches
	 tagged Valid {.wr, .d} :
	    return (wr == r) ? d : rf.sub(r);
	 tagged Invalid : return rf.sub(r);
      endcase
   endmethod
   
endmodule
